<div *ngIf="metas !== undefined && metas.length === 0 || activos == 0"
    class="d-flex flex-column align-items-center justify-content-center vh-100">
    <img src="../../../../../assets/img/NoMetas.png" width="280px" class="img-fluid mb-4 d-block mx-auto">
    <h2 class="text-center">Aún no hay metas</h2>
</div>

<div class="container">
    <div *ngIf=" activos !== 0">
        <h3>Rocas</h3>
        <div class="mt-2">
            <select name="mes" [(ngModel)]="mesSeleccionado" (change)="seleccionarMes()">
                <option value="0">Enero</option>
                <option value="1">Febrero</option>
                <option value="2">Marzo</option>
                <option value="3">Abril</option>
                <option value="4">Mayo</option>
                <option value="5">Junio</option>
                <option value="6">Julio</option>
                <option value="7">Agosto</option>
                <option value="8">Septiembre</option>
                <option value="9">Octubre</option>
                <option value="10">Noviembre</option>
                <option value="11">Diciembre</option>
            </select>
            <select name="mes" [(ngModel)]="anioSeleccionado" (change)="seleccionarMes()">
                <option value="2023">2023</option>
                <option value="2024">2024</option>
                <option value="2025">2025</option>
            </select>
        </div>

        <div class="table-responsive mt-2" style="max-height: 72vh; min-width: 100vh;">
            <table class="table table-striped table-bordered">
                <thead>
                    <tr class="medio">
                        <th>Quien</th>
                        <th>Roca</th>
                        <th>Planeado</th>
                        <th>Real</th>
                        <ng-container *ngFor="let fechas of fechasTabla">
                            <th class="fechas">{{fechas}}</th>
                        </ng-container>
                        <th>Acumulado</th>
                        <th>Comentarios</th>
                    </tr>
                </thead>
                <tbody class="medio">
                    <tr *ngFor="let datos of metas">
                        <td>
                            <img [src]="'http://localhost:8080/imgs/usuarios/' + datos.imagenUsuario"
                                class="pfp d-none d-xl-block d-xxl-block"
                                title="{{datos.nombreUsuario}} {{datos.apellidoUsuario}}" style="margin-left: 30px;">
                        </td>
                        <td class="cursor" title="{{datos.tituloGoal}}" (click)="abrirEditarMetaModal(datos)">
                            {{datos.tituloGoal}}</td>
                        <td>
                            <ng-container
                                *ngIf="(+mesSeleccionado != hoy.getMonth() || +anioSeleccionado != hoy.getFullYear()) && +mesSeleccionado != (hoy.getMonth() - 1); else inputField">
                                {{ datos.planeadoMes }}
                            </ng-container>
                            <ng-template #inputField>
                                <input type="number" name="" #inputPlaneadoMes [value]="datos.planeadoMes || ''"
                                    style="border: none; width: 100%; padding: 0; background: none; outline: none; box-shadow: none; text-align: center; vertical-align: middle;"
                                    (keyup.enter)="datos.planeadoMes === null ? guardarPlaneadoMes(datos.idGoal, inputPlaneadoMes.value) : actualizarPlaneadoMes(datos.idGoal, inputPlaneadoMes.value)">
                            </ng-template>
                        </td>
                        <td>{{datos.realMes}}</td>
                        <ng-container *ngFor="let resultado of seguimientos[datos.idGoal]; let i = index">
                            <td>
                                <ng-container
                                    *ngIf="resultado === null && (+mesSeleccionado != hoy.getMonth() || +anioSeleccionado != hoy.getFullYear()) && +mesSeleccionado != (hoy.getMonth() - 1) || +anioSeleccionado !== hoy.getFullYear(); else inputField">{{resultado}}</ng-container>
                                <ng-template #inputField>
                                    <input type="number" name="" #inputActualizarSeguimiento [value]="resultado"
                                        style="border: none; width: 100%; padding: 0; background: none; outline: none; box-shadow: none; text-align: center;"
                                        (keyup.enter)="resultado === null ? guardarSeguimiento(i, inputActualizarSeguimiento.value, datos): actualizarSeguimiento(i, inputActualizarSeguimiento.value, datos)">
                                </ng-template>
                            </td>
                        </ng-container>
                        <td>{{datos.porcentajeGoal}}</td>
                        <td class="comentarios">
                            <textarea title="{{datos.comentariosGoal}}" #inputComentario
                                [value]="datos.comentariosGoal || ''"
                                style="border: none; padding: 0; background: none; box-shadow: none; text-align: justify; width: fit-content; min-height: 150px; white-space: normal; word-wrap: break-word; overflow-wrap: break-word;"
                                (keyup.enter)="guardarComentario(inputComentario.value, datos.idGoal)">
                            </textarea>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
</div>

<ng-template #editarMetaModal class="modal fade">
    <div class="modal-content">
        <form id="editarMeta">
            <div class="modal-header">
                <h4 class="modal-title">Editar Meta</h4>
                <button type="button" class="close" (click)="cerrarModal()">X</button>
            </div>
            <div class="modal-body">
                <div class="form-group">
                    <label>Nombre Meta</label>
                    <input type="text" class="form-control" id="nombreIndicador" name="nombreIndicador" required
                        [(ngModel)]="meta.tituloGoal">
                </div>
                <div class="form-group">
                    <label>Responsable</label>
                    <select style="color: black;" class="form-select" name="idUsuario" [(ngModel)]="meta.idUsuario">
                        <option *ngFor="let integrante of participantes" [value]="integrante.idUsuario">
                            {{ integrante.nombre }} {{integrante.apellido}}
                        </option>
                    </select>
                </div>
                <div class="form-group">
                    <button class="btn btn-danger mt-3" (click)="archivarMeta()">Archivar</button>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" (click)="cerrarModal()">Cancelar</button>
                <button type="button" class="btn btn-success" (click)="editarMeta()">Editar</button>
            </div>
        </form>
    </div>
</ng-template>